using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.EnterpriseServices;
using System.Runtime.InteropServices;

namespace ObjectPoolingPerformance
{
	/// <summary>
	/// Pooling   Դϴ.
	/// </summary>
	[Transaction(TransactionOption.Required)]//, Isolation=TransactionIsolationLevel.ReadUncommitted)]
	[JustInTimeActivation(true)]
	[ObjectPooling(true)]
	[ClassInterface(ClassInterfaceType.AutoDual)]
	public class Pooling : ServicedComponent
	{
		private bool isEnlisted = false;
		private SqlConnection conn = null;
		private readonly string connectionStringAppKeyName = "TestDB_For_Pooling";

		
		private readonly string columnName_1 = "cust_id";
		private readonly string columnName_2 = "company";
		private readonly string columnName_3 = "contact_name";
		private readonly string columnName_4 = "address";
		private readonly string columnName_5 = "city";
		private readonly string columnName_6 = "state_province";
		private readonly string columnName_7 = "postal_code";
		private readonly string columnName_8 = "country";
		private readonly string columnName_9 = "telephone";
		private readonly string columnName_10 = "fax";

		public Pooling()
		{
			try
			{
				if( conn == null )
				{
					string connectionString = ConfigurationSettings.AppSettings[connectionStringAppKeyName];
					
					conn = new SqlConnection(connectionString);
				}

				if( conn.State != ConnectionState.Open ) 
				{
					conn.Open();
				}

				conn.InfoMessage  += new SqlInfoMessageEventHandler(OnInfoMessage);

			}
			catch(Exception ex)
			{
				throw ex;
			}
		}


		protected override void Activate()
		{
			if( ContextUtil.IsInTransaction == true )
			{
				isEnlisted = true;
			}
			else
			{
				conn.EnlistDistributedTransaction((ITransaction)ContextUtil.Transaction);
				isEnlisted = true;
			}
		} // end of method Activate

		protected override void Deactivate()
		{
			if( isEnlisted )
			{
				conn.EnlistDistributedTransaction(null);
				isEnlisted = false;
			}
		} // end of method Deactivate

		protected override bool CanBePooled()
		{
			if( conn.State == ConnectionState.Open ) 
			{
				return true;
			}
			else
			{
				// conn.Close();
				// conn.Dispose();
				return false;
			}
		} // end of method CanBePooled


		protected static void OnInfoMessage(object sender, SqlInfoMessageEventArgs args)
		{
			foreach (SqlError err in args.Errors)
			{
				Console.WriteLine("The {0} has received a severity {1}, state {2} error number {3}\n" +
					"on line {4} of procedure {5} on server {6}:\n{7}",
					err.Source, err.Class, err.State, err.Number, err.LineNumber, 
					err.Procedure, err.Server, err.Message);
			}
		}

		[AutoComplete(true)]
		public void Retrieve()
		{
			string cmdText = "SELECT * FROM cust";

			using(SqlCommand command = new SqlCommand(cmdText,conn))
			{
				using(SqlDataReader reader = command.ExecuteReader())
				{
					while(reader.Read())
					{
						string column_7 = (string)reader[columnName_7];
						string column_2 = (string)reader[columnName_2];
						string column_4 = (string)reader[columnName_4];
						string column_9 = (string)reader[columnName_9];
						string column_6 = (string)reader[columnName_6];
						string column_10 = (string)reader[columnName_10];
						string column_8 = (string)reader[columnName_8];
						string column_5 = (string)reader[columnName_5];
						string column_1 = (string)reader[columnName_1];
						string column_3 = (string)reader[columnName_3];
					}
				}
			}
			
		}

	}
}
