using System;
using System.Configuration;
using System.Data.SqlClient;

namespace SQLReaderPerformance.SqlDataReaderTest
{
	/// <summary>
	/// Casting   Դϴ.
	/// </summary>
	public class Casting
	{
		private string connectionString;
		private readonly string connectionStringAppKeyName = "TestDB";

		private readonly string columnName_1 = "cust_id";
		private readonly string columnName_2 = "company";
		private readonly string columnName_3 = "contact_name";
		private readonly string columnName_4 = "address";

		public Casting()
		{
			connectionString = ConfigurationSettings.AppSettings[connectionStringAppKeyName];
		}

		public void GetDataType()
		{
			string cmdText = "SELECT * FROM cust2";

			using(SqlConnection conn = new SqlConnection(connectionString))
			{
				conn.Open();

				using(SqlCommand command = new SqlCommand(cmdText,conn))
				{
					using(SqlDataReader reader = command.ExecuteReader())
					{
						int column_ordinal_1 = reader.GetOrdinal(columnName_1);
						int column_ordinal_2 = reader.GetOrdinal(columnName_2);
						int column_ordinal_3 = reader.GetOrdinal(columnName_3);
						int column_ordinal_4 = reader.GetOrdinal(columnName_4);

						while(reader.Read())
						{
							int column_1 = reader.GetInt32(column_ordinal_1);
							int column_2 = reader.GetInt32(column_ordinal_2);
							int column_3 = reader.GetInt32(column_ordinal_3);
							int column_4 = reader.GetInt32(column_ordinal_4);
						}
					}
				}
			}
		}

		public void Cast()
		{
			string cmdText = "SELECT * FROM cust2";

			using(SqlConnection conn = new SqlConnection(connectionString))
			{
				conn.Open();

				using(SqlCommand command = new SqlCommand(cmdText,conn))
				{
					using(SqlDataReader reader = command.ExecuteReader())
					{

						int column_ordinal_1 = reader.GetOrdinal(columnName_1);
						int column_ordinal_2 = reader.GetOrdinal(columnName_2);
						int column_ordinal_3 = reader.GetOrdinal(columnName_3);
						int column_ordinal_4 = reader.GetOrdinal(columnName_4);
		

						while(reader.Read())
						{
							int column_1 = (int)reader[column_ordinal_1];
							int column_2 = (int)reader[column_ordinal_2];
							int column_3 = (int)reader[column_ordinal_3];
							int column_4 = (int)reader[column_ordinal_4];
						}
					}
				}
			}
		}

	}
}
