using System.Configuration;
using System.Data.SqlClient;

namespace SQLReaderPerformance.SqlDataReaderTest
{
	/// <summary>
	/// UsingColumnName   Դϴ.
	/// </summary>
	public class UsingColumnName
	{
		private string connectionString;
		private readonly string connectionStringAppKeyName = "TestDB";

		private readonly string columnName_1 = "cust_id";
		private readonly string columnName_2 = "company";
		private readonly string columnName_3 = "contact_name";
		private readonly string columnName_4 = "address";
		private readonly string columnName_5 = "city";
		private readonly string columnName_6 = "state_province";
		private readonly string columnName_7 = "postal_code";
		private readonly string columnName_8 = "country";
		private readonly string columnName_9 = "telephone";
		private readonly string columnName_10 = "fax";


		public UsingColumnName()
		{
			connectionString = ConfigurationSettings.AppSettings[connectionStringAppKeyName];
		}

		public void Using()
		{
			string cmdText = "SELECT * FROM cust";

			using(SqlConnection conn = new SqlConnection(connectionString))
			{
				conn.Open();

				using(SqlCommand command = new SqlCommand(cmdText,conn))
				{
					using(SqlDataReader reader = command.ExecuteReader())
					{
						while(reader.Read())
						{
							string column_7 = (string)reader[columnName_7];
							string column_2 = (string)reader[columnName_2];
							string column_4 = (string)reader[columnName_4];
							string column_9 = (string)reader[columnName_9];
							string column_6 = (string)reader[columnName_6];
							string column_10 = (string)reader[columnName_10];
							string column_8 = (string)reader[columnName_8];
							string column_5 = (string)reader[columnName_5];
							string column_1 = (string)reader[columnName_1];
							string column_3 = (string)reader[columnName_3];
						}
					}
				}
			}
		}

		public void NotUsing()
		{
			string cmdText = "SELECT * FROM cust";

			using(SqlConnection conn = new SqlConnection(connectionString))
			{
				conn.Open();

				using(SqlCommand command = new SqlCommand(cmdText,conn))
				{
					using(SqlDataReader reader = command.ExecuteReader())
					{
						int column_ordinal_1 = reader.GetOrdinal(columnName_1);
						int column_ordinal_2 = reader.GetOrdinal(columnName_2);
						int column_ordinal_3 = reader.GetOrdinal(columnName_3);
						int column_ordinal_4 = reader.GetOrdinal(columnName_4);
						int column_ordinal_5 = reader.GetOrdinal(columnName_5);
						int column_ordinal_6 = reader.GetOrdinal(columnName_6);
						int column_ordinal_7 = reader.GetOrdinal(columnName_7);
						int column_ordinal_8 = reader.GetOrdinal(columnName_8);
						int column_ordinal_9 = reader.GetOrdinal(columnName_9);
						int column_ordinal_10 = reader.GetOrdinal(columnName_10);

						while(reader.Read())
						{
						
							string column_7 = (string)reader[column_ordinal_7];
							string column_2 = (string)reader[column_ordinal_2];
							string column_4 = (string)reader[column_ordinal_4];
							string column_9 = (string)reader[column_ordinal_9];
							string column_6 = (string)reader[column_ordinal_6];
							string column_10 = (string)reader[column_ordinal_10];
							string column_8 = (string)reader[column_ordinal_8];
							string column_5 = (string)reader[column_ordinal_5];
							string column_1 = (string)reader[column_ordinal_1];
							string column_3 = (string)reader[column_ordinal_3];
						}
					}
				}
			}
		}
	}
}
